package pro.litvinovg.w2phtml.gui;

import static pro.litvinovg.w2phtml.gui.Contstants.*;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.HashMap;

import javax.swing.GroupLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.GroupLayout.Alignment;

public class ControlPanel extends BasePanel {
	public ControlPanel(HashMap<String,Component> configuration,Localizer localizer, JFrame singleFrame) {
		super(localizer, singleFrame);

		JButton btn_Exit = new JButton(localizer.getTranslation(BUTTON_EXIT_LABEL));
		btn_Exit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				singleFrame.setVisible(false);
				singleFrame.dispose();
			}
		});
		
		JButton btn_SaveAs = new JButton(localizer.getTranslation(BUTTON_SAVEAS_LABEL));
		btn_SaveAs.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent actionEvent) {
				JOptionPane.showMessageDialog(singleFrame, localizer.getTranslation(MESSAGE_NOT_IMPLEMENTED));
			}
		});
		JButton btn_Save = new JButton(localizer.getTranslation(BUTTON_SAVE_LABEL));
		btn_Save.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent actionEvent) {
				JOptionPane.showMessageDialog(singleFrame, localizer.getTranslation(MESSAGE_NOT_IMPLEMENTED));
			}
		});
		JButton btn_startConversion = new JButton(localizer.getTranslation(BUTTON_CONVERT_LABEL));
		btn_startConversion.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent actionEvent) {
				try {
				ConversionExecutor executor = new ConversionExecutor(configuration, singleFrame);
					executor.convert();
				} catch(Throwable e) {
					StringWriter errors = new StringWriter();
					e.printStackTrace(new PrintWriter(errors));
					JOptionPane.showMessageDialog(singleFrame,errors.toString());
				}
			}
			
		});
		
		GroupLayout gl_panel_control = new GroupLayout(this);
		gl_panel_control.setHorizontalGroup(
			gl_panel_control.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_control.createSequentialGroup()
					.addGap(83)
					.addComponent(btn_Exit, GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
					.addGap(18)
					.addComponent(btn_SaveAs, GroupLayout.PREFERRED_SIZE, 140, GroupLayout.PREFERRED_SIZE)
					.addGap(18)
					.addComponent(btn_Save, GroupLayout.PREFERRED_SIZE, 120, GroupLayout.PREFERRED_SIZE)
					.addGap(18)
					.addComponent(btn_startConversion, GroupLayout.PREFERRED_SIZE, 100, GroupLayout.PREFERRED_SIZE)
					.addContainerGap(427, Short.MAX_VALUE))
		);
		gl_panel_control.setVerticalGroup(
			gl_panel_control.createParallelGroup(Alignment.LEADING)
				.addGroup(gl_panel_control.createSequentialGroup()
					.addContainerGap()
					.addGroup(gl_panel_control.createParallelGroup(Alignment.BASELINE)
						.addComponent(btn_SaveAs)
						.addComponent(btn_Save)
						.addComponent(btn_Exit)
						.addComponent(btn_startConversion))
					.addContainerGap(GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
		);
						
		this.setLayout(gl_panel_control);
	}
}
