package pro.litvinovg.w2phtml.gui;

import java.awt.Component;
import java.util.HashMap;

import javax.swing.GroupLayout;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.GroupLayout.Alignment;
import javax.swing.LayoutStyle.ComponentPlacement;
import static pro.litvinovg.w2phtml.gui.Contstants.*;


public class PanelFactory {
	
	private Localizer localizer;
	private JFrame singleFrame;
	private PreferencesStorage storage;
	private JTabbedPane tabbedPane;

	public PanelFactory(Localizer localizer,JFrame singleFrame, PreferencesStorage preferences,JTabbedPane tabbedPane) {
		this.localizer = localizer;
		this.singleFrame = singleFrame;
		this.storage = preferences;
		this.tabbedPane = tabbedPane;
	}
	public JPanel createPanel(String type, String name) {
		JPanel panel = new JPanel();
		HashMap<String, Component> configuration = new HashMap<String, Component>();
		JPanel panel_control = new ControlPanel(configuration, localizer, singleFrame);
		JPanel panel_configuration = null;
		if (EPUB.equals(type)){
			panel_configuration = new EpubPanel(configuration, localizer, storage.get(name,type),singleFrame);	
		} else if (RDF.equals(type)) {
			panel_configuration = new RDFPanel(configuration, localizer, storage.get(name,type),singleFrame);	
		} else {
			panel_configuration = new HTMLPanel(configuration, localizer, storage.get(name,type),singleFrame);	
		}
		applyDefaultLayout(panel, panel_configuration, panel_control);
		tabbedPane.addTab(name, null, panel, null);
		return panel;
	}
	
	private void applyDefaultLayout(JPanel tabbedPanel, JPanel configPanel, JPanel controlPanel) {
		
		GroupLayout gl_panel_html = new GroupLayout(tabbedPanel);
		gl_panel_html.setHorizontalGroup(gl_panel_html.createParallelGroup(Alignment.TRAILING)
				.addGroup(gl_panel_html.createSequentialGroup().addGroup(gl_panel_html.createParallelGroup(Alignment.TRAILING)
						.addComponent(configPanel, GroupLayout.DEFAULT_SIZE, 852, Short.MAX_VALUE).addComponent(controlPanel, GroupLayout.DEFAULT_SIZE, 852, Short.MAX_VALUE)).addGap(4)));
		gl_panel_html.setVerticalGroup(gl_panel_html.createParallelGroup(Alignment.LEADING).addGroup(Alignment.TRAILING,
				gl_panel_html.createSequentialGroup()
				.addComponent(configPanel, GroupLayout.DEFAULT_SIZE, 691, Short.MAX_VALUE)
				.addPreferredGap(ComponentPlacement.RELATED)
				.addComponent(controlPanel, GroupLayout.PREFERRED_SIZE, 48, GroupLayout.PREFERRED_SIZE)));
		tabbedPanel.setLayout(gl_panel_html);
	}
	
}
